Program PageMaker { TextProcessor, PageMaker };

{ c Petr Mikulk - Brno - 1989 }

{$G-,R-,S+,V-,E-,N-,D-,L-}
{ $G-,R-,S+,V-,E-,N-,D+,L+}
{$M 16384,0,0}

{ Prvni verze byla v roce 1989 napsana na CP/M.
  ...pak nasledovala jista historie v DOSu.
  6.6.94  pridano ctrl/l end.
  9.7.94  pridano PM4HP.
  11.7.94 jdu davat setupy
  od podzimu 1994 jsem na tomto programu jiz nic nezmenil. Hura.
  Od srpna 1995 davam tento program k dispozici vcetne zdrojaku.
  Do budoucna zbyva jedine: anglicka verze, a zaradit to pak na SimTel.
    Uvidime...
Adresa autora: 
  mikulik@sci.muni.cz, http://www.sci.muni.cz/~mikulik/
}

uses dos, crt, printer, CRTruzne;

const Smax = 200;
      Rmax = $E800 div Smax-17; { 72 nebo 72*1.5=108 }
      ESC  = #$1B;

type Radek   = array[1..Smax] of char;
     Stranka = array[1..Rmax] of Radek;

label 111,112,777;

var MaxSirka,MaxDelka,MR,RVynech,MP,MS,Sirka,SVynech,Delta,Roztec,PocDelka: integer;
    S,R,P,I,J,Rd,Sl,RS,Pg,Lroztec,Rroztec,Paper,PomMR,TabSp,Poz,Back,WhichESC: integer;
    A: Stranka;
    C,CC,Co,Cchar,Jake,Header,KKey: char;
    HeaderNum: integer;
    Zac,CtrlL,CtrlLend,Double,Urezavat,Stop,PrintByHP,EnableESC: boolean;
    Inp,Out: text;
    BuffInp, BuffOut: array [ 1..2048 ] of byte;
    Finp,Fout,BatchMode: PathStr;
    OnlyYourInit: boolean;
    Long: longint;
    TimeDate: DateTime;
    St: String[253];

type

  TSetUp = record
    sIsUsed: boolean;
    sDelta, sRVynech, sMR, sMaxDelka, sSVynech, sMS, sRoztec,
    sMP, sMaxSirka, sBack, sPocDelka, sWhichESC: integer;
    sCchar: char;
    sCtrlL, sCtrlLend, sDouble: boolean;
    sJake: char;
    sTitle: string[80];
    end;

const SUA1=10; const SUA2=19;
const ArraySetUp: array [SUA1..SUA2] of TSetUp
   = ( (), (),(),(),(),(),(),(),(),() );

type

  TESC = record
    sIsUsed: boolean;
    sESC: string[128];
    sTitle: string[80];
    end;

const WhichESCmax=10;
const SI=#$0F;
const ArrayESC: array [1..WhichESCmax] of TESC
   = ( (sIsUsed:true;sESC:ESC+'@'+ESC+'M'+ESC+SI+ESC+'U'+#0;
        sTitle:'EPSON/STAR, 132 znak na dek (condensed tisk)'),
       (sIsUsed:true; sESC:ESC+'@'+ESC+'M'+ESC+SI+ESC+'3'#17+ESC+'S'+#0+ESC+'C'#0#6+ESC+'U'+#0;
        sTitle:'EPSON/STAR, maximln zhutn tisk'),
       (sIsUsed:true; sESC:'E&l0O&l3A&l6D&l72P&l0E&l72F(0U(s0P(s10H(s10V(s3T(10U(s0p10.00h12.0v0s0b3T&l0O';
        sTitle:'HPDJ 72 dk/strnku, max. 96 znak na dek (PM4HP -x72 -g0 -e)'),
       (sIsUsed:true; sESC:'E&l0O&l3A&l6D&l72P&l0E&l72F(0U(s0P(s10H(s10V(s3T(10U(s0p16.67h10.0v0s0b3T&l0O';
        sTitle:'HPDJ 72 dk/strnku, max. 133 znak na dek (PM4HP -x72 -g11 -e)'),
       (sIsUsed:true; sESC:'E&l0O&l3A&l6D&l72P&l0E&l72F(0U(s0P(s10H(s10V(s3T(10U(s0p20.00h12.0v0s0b3T&l0O';
        sTitle:'HPDJ 72 dk/strnku, max. 160 znak na dek (PM4HP -x72 -g21 -e)'),
       (sIsUsed:true; sESC:'E&l0O&l3A&l12D&l144P&l0E&l144F(0U(s0P(s10H(s10V(s3T(10U(s0p16.67h8.0v1s0b4101T&l0O';
        sTitle:'HPDJ 144 dk/strnku, max. 133 znak na dek (PM4HP -x144 -g17 -e)'),
       (),(),(),({sIsUsed:true;sESC:'NO ESC';sTitle:'DEBUG'}) );


function Key: char;
begin if KeyPressed then Key:=ReadKey else Key:=chr(0) end;

procedure Press; var I: integer;
begin
for I:=1 to 20 do write(chr(13),'Stiskem pokrauj...');
repeat until KeyPressed; if Key='' then; writeln
end;

function StrLead  ( L: longint; Mist: integer ): string;
var S: string; K: integer;
begin str(L,S); for K:=1 to Mist-length(S) do S:='0'+S;
StrLead:=S end;

function Chyba: boolean; var V: integer; E: boolean;
begin
E:=false;
if MaxSirka>Smax then begin writeln('MaxSirka je pli velk'); E:=true end;
V:=SVynech+MS*MP+Roztec*(MP-1);
if V>MaxSirka then begin E:=true;
   writeln('Velk ka: ',V:1, ' > ',MaxSirka:1) end;
if MaxDelka>Rmax then begin writeln('MaxDelka je pli velk'); E:=true end;
if RVynech+MR>MaxDelka then begin E:=true;
   writeln('Velk dlka: ',RVynech+MR:1,' > ', MaxDelka:1) end;
if (WhichEsc<>0) then
  if (WhichESC<0) or (WhichESC>WhichESCmax) or not(ArrayESC[WhichEsc].sIsUsed)
    then begin writeln('Velk/mal/nepouit ESC sekvence');
         E:=true end;
if BatchMode[0]<>#0 then if E then halt(1) else begin Chyba:=E; exit end;
if E then Press; Chyba:=E
end;

procedure Centruj(S:string);
begin writeln('':(80-length(S)) div 2,S) end;

procedure X(var P: integer);
begin
writeln('Pvodn hodnota: ',P:1);
write('Nov hodnota: '); Irn(P);
if Chyba then;
end;

function UpString ( S: string ): string; var I: integer;
begin for I:=1 to length(S) do S[I]:=UpCase(S[I]); UpString:=S end;

procedure DoPrintByHP;
var S,S1: string;
begin
S:='PM4HP -x'+StrLead(MaxDelka,0)+' -g';
if (MaxSirka>133) then S:=S+'21' else
 if (MaxDelka>96) then S:=S+'17' else
 if MaxSirka>92 then S:=S+'11' else S:=S+'0';
S:=S+' -e ';
repeat
writeln('Spoutm tohle: '+S+Fout);
write('Souhlas? [ano=A,Y,O,J, ,ret, ne=N, zmna=Z]: '); re;
repeat until KeyPressed; C:=ReadKey; write(C); wr; writeln; C:=UpCase(C);
if C='N' then exit;
if C='Z' then begin
  write('Tak si pidej parametry: '); CRTruzne.Rs(S1); S:=S+S1;
  if S[length(S)]<>' ' then S:=S+' ';
  writeln end;
until C in ['A','Y','O','J',' ',CR];
SwapVectors; Exec(GetEnv('COMSPEC'), '/C '+S+Fout); SwapVectors;
if DosError <> 0 then case DosError of
  2: writeln('Program PM4HP nenalezen! Jestli ho nem na disku, tak si ho sthni z ftp.muni.cz',CRLF,
             'anebo odnkud jinud.');
  3: writeln('Nedostatek pamti.');
  else WriteLn('Dos error ', DosError) end;
end;

procedure Inic;
{ inicializace matice znaku na strance }
var S,P,R: integer;
begin
for S:=1 to MaxSirka do A[1,S]:=' ';
for P:=1 to MP-1 do A[1,SVynech+(MS+Roztec)*P-Rroztec+1]:=Cchar;
for R:=2 to MR do A[R]:=A[1];
Rd:=1; Sl:=SVynech+1; Pg:=1;
RS:=SVynech+MS { RightSloupec - pravy okraj sloupce textu }
end;

procedure Nastav1;
begin
Delta:=7; RVynech:=4; MR:=64; MaxDelka:=72; SVynech:=0; MS:=80; Roztec:=3;
MP:=1; MaxSirka:=80; Cchar:='!'; CtrlL:=false; Double:= false; Jake:='1';
Back:=$1B; PocDelka:=MaxDelka; CtrlLend:=false;
WhichESC:=0; end;

procedure Nastav2;
begin
Delta:=4; RVynech:=4; MR:=64; MaxDelka:=72; SVynech:=0; MS:=64; Roztec:=3;
MP:=2; MaxSirka:=132; Cchar:='!'; CtrlL:=false; CtrlLend:=false;
Double:=false; Jake:='1'; Back:=$1B; PocDelka:=MaxDelka; WhichESC:=1; end;

procedure NastavH2;
begin
Delta:=10; RVynech:=4; MR:=145; MaxDelka:=153; SVynech:=0; MS:=64; Roztec:=3;
MP:=2; MaxSirka:=132; Cchar:='!'; CtrlL:=false; Double:=false; Jake:='1';
Back:=$1B; PocDelka:=MaxDelka; CtrlLend:=false; WhichESC:=2; end;

procedure NastavHPmax;
begin
Delta:=0; RVynech:=4; MR:=138; MaxDelka:=144; SVynech:=0; MS:=64; Roztec:=3;
MP:=2; MaxSirka:=132; Cchar:='!'; CtrlL:=false; Double:=false; Jake:='1';
Back:=$1B; PocDelka:=MaxDelka; CtrlLend:=false; WhichESC:=6; end;

procedure NastavHPLJ;
begin
Delta:=0; RVynech:=0; MR:=72; MaxDelka:=72; SVynech:=0; MS:=63; Roztec:=3;
MP:=2; MaxSirka:=131; Cchar:='!'; CtrlL:=false; Double:=false; Jake:='1';
Back:=$1B; PocDelka:=MaxDelka; CtrlLend:=false; WhichESC:=0; end;

procedure NastavHPDJ;
begin
Delta:=0; RVynech:=0; MR:=72; MaxDelka:=72; SVynech:=0; MS:=64; Roztec:=3;
MP:=2; MaxSirka:=132; Cchar:='!'; CtrlL:=false; Double:=false; Jake:='1';
Back:=$1B; PocDelka:=MaxDelka; CtrlLend:=false; WhichESC:=4; end;

procedure SaveArraySetUp ( var adresa {: pointer}; sajz: longint );
var SizeOfExePrefix: longint;
    F: file; Name: PathStr;
    W: Word; OK: boolean;
  function GetVarFilePos ( var P {: Pointer} ): longint;
  var S: longint;
  begin
  S:=SizeOfExePrefix + longint( (Dseg-Cseg) shl 4 ) + Ofs(P {^});
  GetVarFilePos:=S;
  end;
begin
Name:=ParamStr(0);
repeat
if lo(DosVersion) >= 3
   then assign(F,ParamStr(0))
   else assign(F,FSearch('PAGE.EXE', GetEnv('PATH')));
{$I-} reset(F,1);
OK:=IOresult=0;
{$I+}
if not OK then begin
  write('Nemohu najt ',Name,'. Zadej sprvnou cestu nebo X pro konec: ');
  CRTruzne.RS(Name); if (length(Name)>0) and (UpCase(Name[1])='X') then exit;
  if Name[length(Name)]<>'\' then Name:=Name+'\';
  Name:=Name+'PAGE.EXE' end;
until OK;
seek(F,8);
BlockRead(F,W,2);
SizeOfExePrefix:=W shl 4;
seek(F,GetVarFilePos(adresa));
BlockWrite(F,adresa,sajz);
{ writeln(longint(@arrayesc),'   ',longint(adresa));
writeln(sizeof(ArrayESC),'   ',sajz); }
{ BlockWrite(F,ArrayESC,sizeof(ArrayESC)); }
close(F); writeln('Konfigurace provedena.'); Press
end;

procedure NastavSe;
var I,Code: integer;
begin
if BatchMode[0]=#0 then begin
  write('Kter slo tvho nastaven [',SUA1,'..',SUA2,'] chce nastavit: '); IRn(I);
  end
  else begin Val(BatchMode,I,Code); if Code<>0 then I:=-111 end;
if (I<SUA1) or (I>SUA2) or not(ArraySetUp[I].sIsUsed) then begin
  re; writeln('Vedle jak ta jedle!'); wr; Press;
  if BatchMode[0]<>#0 then Halt(1) else exit;
  end;
with ArraySetUp[I] do begin
Delta:=sDelta; RVynech:=sRVynech;
MR:=sMR; MaxDelka:=sMaxDelka; SVynech:=sSVynech; MS:=sMS;
Roztec:=sRoztec; MP:=sMP; MaxSirka:=sMaxSirka; Back:=sBack;
PocDelka:=sPocDelka; Cchar:=sCchar; CtrlL:=sCtrlL;
CtrlLend:=sCtrlLend; Double:=sDouble; Jake:=sJake;
WhichESC:=sWhichESC;
end end;

procedure UlozSe;
var I: integer;
begin
write('Kter slo tvho nastaven [',SUA1,'..',SUA2,']: '); IRn(I);
if (I<SUA1) or (I>SUA2) then begin
  re; writeln('Vedle jak ta jedle!'); wr; Press; exit end;
with ArraySetUp[I] do begin
write('Nzev tvho nastaven: '); CRTruzne.RS(sTitle);
sIsUsed:=true; sDelta:=Delta; sRVynech:=RVynech;
sMR:=MR; sMaxDelka:=MaxDelka; sSVynech:=SVynech; sMS:=MS;
sRoztec:=Roztec; sMP:=MP; sMaxSirka:=MaxSirka; sBack:=Back;
sPocDelka:=PocDelka; sCchar:=Cchar; sCtrlL:=CtrlL;
sCtrlLend:=CtrlLend; sDouble:=Double; sJake:=Jake;
sWhichESC:=WhichESC;
SaveArraySetUp({@}ArraySetUp,sizeof(ArraySetUp));
end end;


procedure SmazSe;
var I: integer;
begin
write('Kter slo tvho nastaven [',SUA1,'..',SUA2,'] chce smazat: '); IRn(I);
if (I<SUA1) or (I>SUA2) or (not ArraySetUp[I].sIsUsed)
  then begin re; writeln('Vedle jak ta jedle!'); wr; Press; exit end;
ArraySetUp[I].sIsUsed:=false;
SaveArraySetUp({@}ArraySetUp,sizeof(ArraySetUp));
end;


procedure VypisESC;
var i: integer;
begin
writeln('Tv oblben ESC sekvence jsou:',CRLF);
writeln(0:2,'  dn ESC sekvence');
for I:=1 to WhichESCmax do with ArrayESC[i] do
  if sIsUsed then
    writeln(i:2,'  ',sTitle,CRLF,'    ',sESC);
end;

procedure NastavESC;
var I,k: integer; S: PathStr; inp: text;
begin
VypisESC;
write('Kterou chce pepsat [1..',WhichESCmax,',jinak konec]: '); IRn(I);
if (I<1) or (I>WhichESCmax) then begin
  re; writeln('dn se nepepisuje.'); wr; Press; exit end;
with ArrayESC[I] do begin
write('Nzev tv sekvence: '); CRTruzne.RS(sTitle);
write('Jmno souboru, v nm je uloena: ');
S:='ESC.TMP'; CRTruzne.RS(S);
{$I-} assign(inp,S); reset(inp);
if IOresult<>0 then begin writeln('Soubor ',S,' neexistuje!');
  write('Vymazat danou ESC sekvenci? [A,Y,O,J=ano]: ');
  CRTruzne.Rc(c);
  if upcase(C) in ['A','Y','O','J'] then sIsUsed:=false;
  exit end;
k:=0; while (k<sizeof(ArrayESC[i].sESC)-1) and not(eof(inp)) do
  begin inc(k); read(inp,ArrayESC[i].sESC[k]) end;
if (k=sizeof(ArrayESC[i].sESC)-1) and not eof(inp) then
  writeln('Soubor pli dlouh, nateno pouze ',sizeof(ArrayESC[i].sESC)-1,' znak.');
close(inp);
ArrayESC[i].sESC[0]:=char(k);
sIsUsed:=true;
SaveArraySetUp({@}ArrayESC,sizeof(ArrayESC));
end end;


procedure ZhustenyTisk; const SI=#$0F;
begin
(* ESC M - select 12-pitch characters
   ESC SI - select condensed printing (SI=$0f)
   FF = $0c
   ESC S n - horni 0, dolni index 1
   ESC 3 n - velikost radkovani na n/216 palce (napr. 17)
   ESC C NUL n - delka papiru v palcich
   ESC @ - inic tiskrny
   ESC U n - obousmerny 0/jednosmerny 1 tisk *)
write(lst,ESC,'@',ESC,'M' {elite},ESC,SI,ESC,'3',#17,ESC,'S',#0,
          ESC,'C',#0,#6 {6 palcu},ESC,'U',#0);
end;

procedure Tisk132; const SI=#$0F;
begin
write(lst,ESC,'@',ESC,'M' {elite},ESC,SI,ESC,'U',#0);
end;

procedure Copyright;
var A: array[1..28] of byte; S: string;
begin
A[18]:=169;A[19]:=73;A[20]:=81;A[21]:=79;A[22]:=237;A[23]:=211;A[24]:=237;
writeln;A[12]:=85;A[13]:=91;A[14]:=87;A[28]:=127;A[15]:=237;A[16]:=211;A[17]:=237;
for R:=1 to 40-14 do write(' ');A[25]:=203;A[26]:=187;A[27]:=189;A[28]:=187;
A[1]:=103;A[25]:=203;A[2]:=237;A[3]:=141;A[4]:=99;A[5]:=69;A[6]:=73;A[7]:=237;A[8]:=147;A[9]:=91;A[10]:=87;A[11]:=67;
for I:=1 to 28 do
  if I<>13 then write(chr((301-A[I]) div 2))
           else write(char(162-round(sin(0))-1));
writeln
end;

procedure Zapis;
{ ulozi pole A do output file, A inicializuje }
label 1; var R,S,I: integer;
begin
if (Jake='1') or ( (Jake='2') and odd(Paper) ) or ( (Jake='3') and not odd(Paper) )
 then begin
      write('Probh tisk strany slo ');
      if Jake='1' then writeln(Paper:1 { ,chr($A) } )
                  else writeln((Paper+1) div 2:1 { ,chr($A) } );
 for R:=1 to MR do
   begin
   I:=SVynech+Pg*MS+(Pg-1)*Roztec;  { RS; }
   while (A[R,I]=' ') and (I>1) do I:=I-1; { vynechani pravych mezer }
   if (Co='T') and Urezavat and (I>80) then I:=80;
   for S:=1 to I do
     begin
     if KeyPressed then if UpCase(Key)=#$1B then
       begin re; write('Peruit vpis? [A]: '); rc(C);
       if UpCase(C)='A' then begin Stop:=true; goto 1 end end;
     write(Out,A[R,S])
     end;
   if Double then
     begin
     write(Out,CR);
     for S:=1 to I do
       begin
       if KeyPressed then if UpCase(Key)=#$1B then
         begin re; write('Peruit vpis? [A]: '); rc(C);
         if UpCase(C)='A' then begin Stop:=true; goto 1 end end;
       write(Out,A[R,S])
     end end;
   if not( Urezavat and (Co='T') and (I=80) ) then writeln(Out);
   end;
if Zac then begin MR:=PomMR; Zac:=false end;
if not eof(Inp) then
  begin
  for R:=1 to MaxDelka-MR do writeln(Out);
  Inic
  end
end;
Paper:=Paper+1;
1:end;

procedure PisTXT; var X: string[51];
begin X:='P r o g r a m  P A G E  -  prava textu do strnek'; Centruj(X) end;

procedure NextLine;
{ ukonceni zapisovani radku v matici A }
begin
Rd:=Rd+1; Sl:=RS-MS+1;
if Rd>MR then
  begin
   Rd:=1; Pg:=Pg+1; Sl:=Sl+MS+Roztec; RS:=RS+MS+Roztec;
   if Pg>MP then begin Pg:=Pg-1; Zapis end
  end
end;

{ +++ VLASTNI PROGRAM +++ }

label Batch_0, Batch_1, Batch_2, Batch_3;
begin
Nastav2; Finp:='X.INP'; Fout:='X.OUT'; Header:='N';
OnlyYourInit:=false; BatchMode:='';
if (ParamCount>=1) and (ParamCount<=4) then Finp:=ParamStr(1);
if (ParamCount>=2) and (ParamCount<=4) then Fout:=ParamStr(2);
if (ParamCount>=3) and (ParamCount<=4) then
  begin
     OnlyYourInit:=ParamCount=3;
     PisTXT; Copyright;
     BatchMode:=ParamStr(3); Co:='G';
     if BatchMode='0' then goto Batch_2
       else begin if BatchMode[0]=#1 then CC:=BatchMode[1] else CC:='R';
            goto Batch_1 end;
  end;
Batch_0: BatchMode:='';
TextBackground(blue); TextColor(yellow);
ClrScr; PisTXT; Copyright;
if (ParamCount<1) or (ParamCount>3) then
    begin
    writeln(CRLF,'Syntaxe:  PAGE  [vstupn_soubor  [vstupn_soubor [n] ] ]',CRLF,
            '               = pro interaktivn reim.  n  znamen standardn nastaven.',CRLF,
            'Syntaxe:  PAGE  vstupn_soubor  vstupn_soubor  n  X',CRLF,
            '               = pro batch reim: pouij standardn nastaven slo  n',CRLF,
            '                 a transformuj vstupn na vstupn soubor. X je lib. etzec.',CRLF,CRLF);
    write('Vstupn soubor: '); CRTruzne.RS(Finp)
    end;
repeat
EnableESC:=true;
ClrScr; Centruj('Program PAGE --- MENU:'); writeln;
writeln('0 ... Delta=',Delta:1,' - poet dk mezi hlavic a pravtkem tiskrny');
writeln('1 ... RVynech=',RVynech:1,' - poet vynechvanch dk');
writeln('2 ... MR=',MR:1,' - poet tisknutch dk na strnce');
writeln('3 ... MaxDelka=',MaxDelka:1,' - max. poet dk na strnce tiskrny');
writeln('4 ... SVynech=',SVynech:1,' - poet vynech. znak na za. dky');
writeln('5 ... MS=',MS:1,' - poet znak ve sloupci');
writeln('6 ... Roztec=',Roztec:1,' - vzdlenost dvou sloupc tisku');
writeln('7 ... MP=',MP:1,' - poet sloupc (pages) textu na strnce');
writeln('8 ... MaxSirka=',MaxSirka:1,' - max. poet znak na dek tiskrny');
writeln('9 ... PocDelka=',PocDelka:1,' - poet volnch dk na zaloenm papru');
writeln;
Centruj('Mus platit ( tiskrna nen natahovac ):');
writeln('SVynech+MS*MP+Roztec*(MP-1) <= MaxSirka     RVynech+MR <= MaxDelka');
writeln;
writeln('C ... CChar="',Cchar,'" - znak mezi sloupci      D ... dvojnsobn petisk: ',Double);
if CtrlL then Co:='Y' else Co:='N';
if CtrlLend then CC:='Y' else CC:='N';
writeln('L ... zanat/konit znakem FF: ',Co,'/',CC,'      S ... standardn nastaven');
writeln('? ... zjitn promnn PocDelka         H ... help       E ... ESC seq: ',WhichESC:1);
writeln('I ... vstupn soubor: ',UpString(Finp),'':16-length(Finp),'   O ... vstupn soubor: ',UpString(Fout));
writeln('J ... Jake=',Jake,' strany: 1-vechny, 2-lich, 3-sud   V ... zhlav ',Header,': Ne/Ano/Male');
writeln('Vstupy: G...soubor, T...con, P...prn, N...nul      Konec: K');
writeln; write('Co sis vybral: '); rc(Co);
Co:=UpCase(Co); writeln; writeln;

case Co of
'0': X(Delta); '1':X(RVynech); '2':X(MR);
'3': begin X(MaxDelka); write('Nastavit poet dk na zaloenm papru na tut hodnotu? [N=ne]: ');
     repeat until KeyPressed; if UpCase(ReadKey)<>'N' then PocDelka:=MaxDelka end;
'4':X(SVynech); '5':X(MS); '6':X(Roztec);
'7':X(MP); '8':X(MaxSirka); '9':X(PocDelka);
'E':begin VypisESC; X(WhichESC) end;
'V':begin repeat write('Hlavicka [Ne/Ano/Mala]: '); Rc(Header);
    Header:=UpCase(Header) until Header in ['A','N','M'] end;
'D': Double:=not Double;
'J':begin repeat
    write('Kter strany tisnout? 1 - vechny, 2 - lich, 3 - sud: '); rc(Jake)
    until Jake in ['1'..'3']; end;
'O','I': begin write('Jmno souboru: ');
         if Co='I' then CRTruzne.RS(Finp) else CRTruzne.RS(Fout) end;
'C': begin write('Novy oddlova: '); rc(Cchar) end;
'L': begin write('Form feed (CTRL/L) na zatek souboru? y/n: '); rc(CC);
     CC:=UpCase(CC); CtrlL:=CC='Y';
     write('Form feed (CTRL/L) na konec souboru? y/n: '); rc(CC);
     CC:=UpCase(CC); CtrlLend:=CC='Y' end;
'S':begin
    writeln('1 ... nastaven pro tisk jedn strnky pro EPSON/STAR');
    writeln('2 ... 2 strnky textu pro EPSON/STAR');
    writeln('3 ... 2 strnky textu v maximln zhutnm tvaru pro EPSON/STAR');
    writeln('4 ... 2 strnky textu pro HPLJ (131 znak na dek, pouit fontu 21 u HPLJ II)');
    writeln('5 ... 2 strnky textu pro HPDJ (132 znak na dek)');
    writeln('6 ... 2 strnky textu v maximln zhutnm tvaru pro HPDJ');
    writeln('C ... nastavit tiskrnu EPSON/STAR na 132 znak na dek (condensed tisk)');
    writeln('H ... nastavit tiskrnu EPSON/STAR na maximln zhutn tisk');
    writeln('R ... nahrej si sv nastaven menu');
    writeln('S ... ulo si aktuln nastaven menu');
    writeln('D ... smazej sv nastaven menu');
    writeln('E ... vypi/nastav/smazej si svou oblbenou ESC sekvenci');
    writeln('***** seznam tvch nastaven menu: *****');
    for i:=SUA1 to SUA2 do
      with ArraySetup[i] do if sIsUsed then
        writeln('Nastaven ',i:2,':   ',sTitle);
    writeln('****************************************');
    write('Co sis vybral: '); rc(CC);
    Batch_1:
    case UpCase(CC) of '1':Nastav1; '2':Nastav2; '3': NastavH2;
                       '4':NastavHPLJ;
                       '5':NastavHPDJ;
                       '6':NastavHPmax;
                       'C':Tisk132;
                       'H':ZhustenyTisk;
                       'R':NastavSe;
                       'S':UlozSe;
                       'D':SmazSe;
                       'E':NastavESC;
                       else begin
                       writeln('Nic se neprovd.');
                       if BatchMode[0]<>#0 then halt(1);
                       Press end;
                       end;
    Batch_2: if BatchMode[0]<>#0 then
      if OnlyYourInit then goto Batch_0 else goto Batch_3;
    end;
'H':begin ClrScr; writeln(CRLF); PisTXT; Copyright;
    Centruj('Adresa autora:  mikulik@sci.muni.cz'); writeln;
    Centruj('Historie: verze CP/M: 1989 (na vydn u autora), verze DOS: 1990-1994');
    writeln(CRLF,'HELP:',CRLF,'-----',CRLF);
    writeln('Program  PAGE  slou ke sluovn textu do vce sloupc  vedle');
    writeln('sebe, co je vhodn zejmna pi tisku dlouhch sloupc dat, pi');
    writeln('vpisu listing  nebo pi pouvn irokho  papru na  irok');
    writeln('tiskrn.',CRLF,CRLF,
    'Parametry pro vzhled strnky se zadvaj z menu. asto uvan nastaven',CRLF,
    'menu je mon nakonfigurovat pmo do exe souboru - volbou S...standardn',CRLF,
    'nastaven, S...ulo si sv nastaven. Nastaven jde obnovit volbou S...',CRLF,
    'standardn nastaven, R...nahrej si sv nastaven menu, i pmo volnm',CRLF,
    'programu  page vstupni_soubor vystupni_soubor cislo_nastaveni.',CRLF,
    '  Je t mon nakonfigurovat ESC sekvence pro pouvanou tiskrnu. Pro',CRLF,
    'STAR/EPSON a HPDJ jsou ji nastaveny.',CRLF,
    '  Pro zjitn sprvn syntaxe spus program PAGE bez parametr.');
(***
    repeat
    write('M tiskrna zptn posuv vlce? [A/N]: '); rc(C); C:=UpCase(C)
    until (C='A') or (C='N');
    if C='N'
    then Back:=-1
    else begin
    repeat
    write('Je ASCII hodnota znaku posuvu zpt 1Bh? [A/N]: '); rc(C); C:=UpCase(C);
    until C in ['A','N'];
    if C='A' then Back:=$1B
             else begin write('Jeho ASCII hodnota: '); rc(Back);
                  writeln('Je mi lito, ale mas smulu...'); end;
    end;
***)
    Press end;
'?':begin
    R:=Delta; S:=1; ClrScr;
    writeln('Tahle funkce funguje korektn pro jistou zbrojovckou tiskrnu.');
    writeln('Pro jin tiskrny to jen odsune papr dol, ale ji nevrt zpt.');
    writeln('Zmkn ESC pro oputn tto funkce.',CRLF);
    writeln('A perforace papru vyjede nad pravtko, pak zmakni <CR>,');
    writeln('jinak makej E, X, S, D, F. Konec: <CR>'); delay(800); writeln;
    repeat
    write('dk od zatku papiru: ',R:1,'     Pozice: ',S:1,chr(13)); delay(333);
    repeat until KeyPressed;
    KKey:=Key;
    case UpCase(KKey) of
              'E': if Back<>-1 then begin write(lst,chr(Back)); R:=R-1 end;
              'X': begin write(lst,chr($A)); R:=R+1 end;
              'S': begin write(lst,chr($D)); S:=1 end;
              'F': begin write(lst,'     '); S:=S+5 end;
              'D': begin write(lst,' '); S:=S+1 end end;
    until (KKey=chr($0D)) or (KKey=chr($0A)) or (KKey=ESC);
    if KKey<>ESC then begin
    PocDelka:=R-Delta; writeln('PocDelka nastavena na tuto hodnotu: ',PocDelka:1);
    if Back=-1 then begin writeln('Nyn nastav papr do pvodn polohy.'); Press end
               else begin writeln('Nyn nastavm papr do pvodn polohy.');
                    for R:=1 to PocDelka do write(lst,chr(Back)) end
    end end;
'G','T','P','N':
   Batch_3:
   if not Chyba then
   begin
   PrintByHP:=false;
   {$I-} assign(Inp,Finp); reset(Inp); SetTextBuf(Inp,BuffInp);
   if IOresult<>0
     then begin writeln('Soubor ',Finp,' neexistuje.'); goto 112 end;
   {$I+} writeln(chr($A),'Vpis je mon ukonit klvesou ESC'); writeln;
    case Co of
    'G': begin assign(Out,Fout); rewrite(Out); SetTextBuf(Out,BuffOut) end;
    'P': begin
         assign(Out,'prn'); {$I-} rewrite(Out);
         if IOresult<>0 then
           begin writeln('Tiskrna nepipravena.'); Press;
           close(Inp); goto 777 end;
         write(Out,chr($D));
         if IOresult<>0 then
           begin writeln('Tiskrna nepipravena.'); Press;
           close(Inp); goto 777 end;
         {$I+}
         { if SVynech+MS*MP+Roztec*(MP-1) > 80 then }
           begin
           writeln('Nastavit jinak tiskrnu ?');
           writeln('C ... nastavit EPSON/STAR na 132 znak na dek (condensed tisk)');
           writeln('H ... nastavit EPSON/STAR na maximln zhutn tisk');
           writeln('E ... vytisknout bez ESC sekvence');
           writeln('X ... tisknout na HP tiskrn programem PM4HP.EXE bez ESC sekvence');
           writeln('N ... netisknout');
           write(  'jinak nenastavovat: ');
           repeat until KeyPressed; C:=ReadKey; re; writeln(C); wr;
           case UpCase(C) of 'H': ZhustenyTisk; 'C': Tisk132;
                'N': goto 777; 'E': EnableESC:=false;
                'X': begin PrintByHP:=true; CC:='G'; close(Out);
                     assign(Out,Fout); rewrite(Out); SetTextBuf(Out,BuffOut);
                     EnableESC:=false;
                     end end;
           end
         end;
    'T': begin AssignCrt(Out); rewrite(Out);
         Urezavat:=false;
         if SVynech+MS*MP+Roztec*(MP-1) > 80 then
           begin
           write('Uezvat dky del 80 znak [A=ano] ? ');
           repeat until KeyPressed; C:=ReadKey; re; writeln(C); wr; DelLine;
           Urezavat:=UpCase(C)='A';
         end end;
    'N': begin assign(Out,'nul'); rewrite(Out); writeln('Bude vypsn poet potitnch papr:',chr($A)) end
    end;
   Lroztec:=Roztec div 2; Rroztec:=Roztec-Lroztec; Sirka:=MS+Lroztec;
   Zac:=false; Stop:=false; Poz:=1; TabSp:=0; Paper:=1;
   HeaderNum:=0;
   if EnableESC and (WhichESC>0) then write(Out,ArrayESC[WhichESC].sESC);
   if Header<>'N' then
     begin
     GetFTime(Inp,Long); UnpackTime(Long,TimeDate);
     with TimeDate do
       begin
       if Header='A' then St:='++++++  ' else St:='';
       St:=St+UpString(Finp)+'  ';
       if Header='A' then St:=St+'%%%  ';
       St:=St+StrLead(Day,2)+'.'+StrLead(Month,2)+'.'+StrLead(Year,4);
       St:=St+'  '+StrLead(Hour,2)+':'+StrLead(Min,2)+':'+StrLead(Sec,2);
       if Header='A' then St:=St+'  ++++++';;
       end;
     S:=length(St); { S:=SVynech+MS*MP+Roztec*(MP-1); }
     if Header='A' then
       begin write(out,'++++++'); for R:=1 to S-12 do write(out,'+'); writeln(out,'++++++') end;
     writeln(out,St);
     if Header='A' then
       begin write(out,'++++++'); for R:=1 to S-12 do write(out,'+'); writeln(out,'++++++') end;
     writeln(out);
     if Header='A' then HeaderNum:=4 else HeaderNum:=2;
     dec(PocDelka,HeaderNum);
     end;
   if CtrlL
     then write(Out,chr( ord('L')-64 ))   {page(out)}
     else
      begin
       { generovani 1. stranky - zavisi na zalozeni papiru }
       Zac:=true; PomMR:=MR;
       if RVynech>Delta
         then
          begin for R:=1 to RVynech-Delta do writeln(Out);
          MR:=PocDelka-(MaxDelka-MR-RVynech)-RVynech end
         else MR:=PocDelka-(MaxDelka-MR-RVynech)-Delta;
       if MR<3 then {nebude psat 1-2 radky na stranku }
         begin
          for R:=1 to MR+(MaxDelka-PomMR-RVynech) do writeln(Out);
          MR:=PomMR; Zac:=false
         end
      end;
   Inic;
   while not eof(Inp) do
      begin
       while (not eoln(Inp)) do
          begin
           if Sl>RS then NextLine;
           if TabSp=0 then read(Inp,C);
           Poz:=Poz+1;
           if ord(C)=9 then TabSp:=8-Poz mod 8; { nalezen tabulator }
           if TabSp>0 then begin C:=' '; TabSp:=TabSp-1 end;
           if
           (ord(C)=ord('L')-64) and not((Pg=1) and (Sl=SVynech+1) and (Rd=1))
             then Zapis {ctrl/l}
             else begin A[Rd,Sl]:=C;
                  Sl:=Sl+1 end;
          if Stop then goto 111
          end;
       readln(Inp); Poz:=1;
       if not eof(Inp) then NextLine; if Stop then goto 111
      end;
   Zapis; 111:
   if CtrlLend
     then write(Out,chr( ord('L')-64 ));   {page(out)}
   close(Out); close(Inp);
   if PrintByHP then DoPrintByHP;
   112:
   if BatchMode[0]<>#0 then Halt(1);
   Press;
   if HeaderNum<>0 then
     begin inc(PocDelka,HeaderNum); HeaderNum:=0 end;
   end { of 'G' }
end; { of case }

777:
until Co='K';

ClrScr;Centruj('Konec programu PAGE'); writeln; writeln;
Centruj('Program me bt en jako public domain.');
(* Centruj('Program me bt en jako shareware. '); *)
(* writeln(lf,'Pokud se vm lb, zalete, prosm, stku 0 Ks na adresu autora:'); *)
writeln;
RightJust('Petr Mikulk  ');
RightJust('        Brno  ');
writeln; delay(1111);
end. { TXT = PAGE }
